UNIT mTEreignisVerteilerAnwendung;

interface

uses        mSum,mTKnopf;
// Uses-Klausel ggf. anpassen

type
   TEreignisVerteilerAnwendung = CLASS

     // Attribute
     protected
         derBildschirm : Bildschirm;
         dieMaus : Maus;
         dieTastatur : Tastatur;
         ErsterKnopf : TKnopf;
         sender : TObject;
         zBeenden : Wahrheitswert;
         zMausunten : Wahrheitswert;

     // Methoden
     public
        constructor init; virtual;
        procedure bearbeiteLeerlauf;
        procedure bearbeiteMausClick;
        procedure bearbeiteMausDoppelklick;
        procedure bearbeiteTastaturDruck(pZeichen:Zeichen);
        procedure beenden;
        procedure run;
        destructor gibfrei; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TEreignisVerteilerAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TEreignisVerteilerAnwendung.init;
begin
  derBildschirm     := Bildschirm.init;
  dieMaus           := Maus.init;
  dieTastatur       := Tastatur.init;
  zBeenden          := falsch;
  zMausunten        := falsch;
  ErsterKnopf       := TKnopf.init(0,0,0,'ersterKnopf',dieMaus);
end;

  // Aktionsteil

//-------- bearbeiteLeerlauf (public) ----------------------------------
procedure TEreignisVerteilerAnwendung.bearbeiteLeerlauf;
begin
   ersterKnopf.bearbeiteMeinenLeerlauf(sender)
end;

//-------- bearbeiteMausClick (public) ---------------------------------
procedure TEreignisVerteilerAnwendung.bearbeiteMausClick;
begin
    ersterKnopf.bearbeiteMeinenMausClick(sender);
end;

//-------- bearbeiteMausDoppelklick (public) ---------------------------
procedure TEreignisVerteilerAnwendung.bearbeiteMausDoppelklick;
begin
    ersterKnopf.bearbeiteMeinenMausDoppelklick(sender);
end;

//-------- bearbeiteTastaturDruck (public) -----------------------------
procedure TEreignisVerteilerAnwendung.bearbeiteTastaturDruck(pZeichen:Zeichen);
begin
    ersterKnopf.bearbeiteMeinenTastaturdruck(sender,pZeichen)
end;

//-------- beenden (public) --------------------------------------------
procedure TEreignisVerteilerAnwendung.beenden;
begin
   zBeenden := True
end;

//-------- run (public) ------------------------------------------------
procedure TEreignisVerteilerAnwendung.run;
begin
  repeat
     if dieMaus.istGedrueckt
       then begin
              if not zMausUnten
                then begin
                       zMausUnten := True;
                       bearbeiteMausClick
                     end
                else begin
                        bearbeiteLeerlauf
                       //eigentlich : bearbeiteMausUnten
                     end
            end
       else begin //Maus ist nicht gedrckt
              zMausUnten := False;
              if dieMaus.doppelklick
                then begin
                       bearbeiteMausDoppelklick
                     end
                else begin
                       if dieTastatur.wurdeGedrueckt
                         then begin
                                bearbeiteTastaturDruck(dieTastatur.zeichen);
                                dieTastatur.weiter
                              end
                         else begin
                                bearbeiteLeerlauf
                              end
                     end
            end
  until zBeenden
end;

//-------- gibfrei (public) --------------------------------------------
destructor TEreignisVerteilerAnwendung.gibfrei;
begin
   ersterKnopf.gibFrei;
   dieTastatur.gibFrei;
   dieMaus.gibFrei;
   derBildschirm.gibFrei
end;

end.
