UNIT mTSuMTextfeld;

interface

uses      dialogs, sysutils, forms, graphics, mSuM,mTEreignisbearbeiter;
// Uses-Klausel ggf. anpassen

type
   TSuMTextfeld = CLASS(TEreignisbearbeiter)

     // Attribute
     private
        hatBuntstift : Buntstift;
        zHatFokus : Wahrheitswert;
        zBreite : Zahl;
        zHoehe : Zahl;
        zXPos : zahl;
        zYPos : zahl;
        zInhalt : Zeichenkette;

     // Methoden
     private
        function innerhalb : Wahrheitswert;
        procedure schreibe;
     public
        constructor init(pH,pV:zahl;pMaus:Maus);
        procedure bearbeiteMeinenMausClick(sender:TObject); override;
        procedure bearbeiteMeinenTastaturDruck(Sender:TObject;pZeichen:Zeichen); override;
        procedure setzeGroesse(pBreite,pHoehe:Zahl);
        procedure setzeInhalt(pInhalt:Zeichenkette); overload;
        procedure setzeInhalt(pInhalt:Zahl); overload;
        procedure setzePosition(pLinks,pOben:Zahl);
        procedure setzeText(pInhalt:Zeichenkette);
        function breite : Zahl;
        function hoehe : Zahl;
        function inhaltAlsGanzeZahl : GanzeZahl;
        function inhaltAlsText : Zeichenkette;
        function inhaltAlsZahl : Zahl;
        function inhaltIstGanzeZahl : Wahrheitswert;
        function inhaltIstZahl : Wahrheitswert;
        function inhaltIstZeichenkette : Wahrheitswert;
        function links : Zahl;
        function oben : Zahl;
        destructor gibFrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TSuMTextfeld: Methodendefinition 
//+---------------------------------------------------------------------

//-------- innerhalb (private) -----------------------------------------
function TSuMTextfeld.innerhalb : Wahrheitswert;
begin
  result :=
       (kenntMaus.hPosition > zXpos ) and
       (kenntMaus.hPosition < zXPos + zBreite) and
       (kenntMaus.vPosition > zYPos) and
       (kenntMaus.vPosition < zYPos + zHoehe);
end;

//-------- init (public) -----------------------------------------------
constructor TSuMTextfeld.init(pH,pV:zahl;pMaus:Maus);
begin
 inherited init(pmaus);
 zXPos:=pH; zYPos:=pV;
 zHoehe := 25;zBreite := 120;
 zInhalt:='';
 hatBuntstift:=Buntstift.init;
 zHatFokus := falsch;
 self.schreibe;
end;

//-------- bearbeiteMeinenMausClick (public) ---------------------------
procedure TSuMTextfeld.bearbeiteMeinenMausClick(sender:TObject);
begin
  if innerhalb then
     begin
       zHatFokus := wahr;
       schreibe
     end
  else
     if zHatFokus then
        begin
          zHatFokus := falsch;
          schreibe
        end
     else
        zHatFokus := falsch;
  inherited bearbeiteMeinenMausClick(sender);
end;

//-------- bearbeiteMeinenTastaturDruck (public) -----------------------
procedure TSuMTextfeld.bearbeiteMeinenTastaturDruck(Sender:TObject;pZeichen:Zeichen);
var neuerInhalt : Zeichenkette;
    myCanvas : TCanvas;
begin
  if zHatFokus then
    begin
       if pZeichen = ENTFERNEN
          then zInhalt := copy(zInhalt,0,length(zInhalt)-1)
          else
            begin
               neuerInhalt := zInhalt + pZeichen;
               hatBuntStift.setzeSchriftgroesse(24);
               myCanvas := screen.activeform.canvas;
               if myCanvas.TextWidth(neuerInhalt) < zBreite-4 then
                  zInhalt := neuerInhalt;
               hatBuntStift.setzeSchriftgroesse(12);
            end;
       schreibe;
    end;//of zHatFokus
  inherited bearbeiteMeinenTastaturDruck(Sender,pZeichen)
end;

//-------- schreibe (public) -------------------------------------------
procedure TSuMTextfeld.schreibe;
var myCanvas:Tcanvas;
    anzeige :Zeichenkette;
begin
 with hatBuntstift do
   begin
     bewegeBis(zXpos-1,zYpos-1);
     setzefuellmuster(Gefuellt);
     setzefarbe(weiss);
     zeichneRechteck(zBreite+1,zHoehe+1);
     //setzeLinienbreite(2);
     if zHatFokus
        then setzeLinienbreite(2)
        else setzeLinienbreite(1);
     bewegeBis(zXpos,zYpos);
     setzefuellmuster(durchsichtig);
     hatBuntstift.setzefarbe(schwarz);
     zeichneRechteck(zBreite,zHoehe);
     setzeLinienbreite(1);

     setzeSchriftgroesse(24);
     myCanvas := screen.activeform.canvas;
     anzeige := zInhalt;
     if myCanvas.TextWidth(anzeige) > zbreite-4
        then repeat
                anzeige := copy(anzeige,0,length(anzeige)-1)
             until myCanvas.TextWidth(anzeige) <= zbreite-4;
     bewegeBis(zXpos+zbreite-2-myCanvas.TextWidth(anzeige),zYPos+2);
     schreibeText(zInhalt);
     setzeSchriftgroesse(12);
   end;
end;

//-------- setzeGroesse (public) ---------------------------------------
procedure TSuMTextfeld.setzeGroesse(pBreite,pHoehe:Zahl);
begin
 self.zBreite:=round(pBreite);
 self.zHoehe :=round(pHoehe);
 schreibe
end;

//-------- setzeInhalt (public) ----------------------------------------
procedure TSuMTextfeld.setzeInhalt(pInhalt:Zeichenkette);
begin
 self.zInhalt:=pInhalt;
 schreibe
end;

//-------- setzeInhalt (public) ----------------------------------------
procedure TSuMTextfeld.setzeInhalt(pInhalt:Zahl);
begin
 self.setzeText(floatToStr(pInhalt));
 schreibe
end;

//-------- setzePosition (public) --------------------------------------
procedure TSuMTextfeld.setzePosition(pLinks,pOben:Zahl);
begin
 self.zXPos:=round(pLinks);
 self.zYPos:=round(pOben);
 schreibe
end;

//-------- setzeText (public) ------------------------------------------
procedure TSuMTextfeld.setzeText(pInhalt:Zeichenkette);
begin
 self.zInhalt:=pInhalt;
 schreibe
end;

//-------- breite (public) ---------------------------------------------
function TSuMTextfeld.breite : Zahl;
begin
  result:=self.zBreite;
end;

//-------- hoehe (public) ----------------------------------------------
function TSuMTextfeld.hoehe : Zahl;
begin
  result:=self.zHoehe;
end;

//-------- inhaltAlsGanzeZahl (public) ---------------------------------
function TSuMTextfeld.inhaltAlsGanzeZahl : GanzeZahl;
begin
  if self.InhaltIstGanzeZahl then result:=strToInt(self.inhaltAlsText)
  else
  begin
    MessageDlg('Eingabe keine ganze Zahl.',mtError,[mbOK],0);
    result:=0;
  end;
end;

//-------- inhaltAlsText (public) --------------------------------------
function TSuMTextfeld.inhaltAlsText : Zeichenkette;
begin
 result := self.zInhalt;
end;

//-------- inhaltAlsZahl (public) --------------------------------------
function TSuMTextfeld.inhaltAlsZahl : Zahl;
begin
  if self.InhaltistZahl then result:=strTofloat(self.inhaltAlsText)
  else
  begin
    MessageDlg('Eingabe keine Zahl.',mtError,[mbOK],0);
    result:=0;
  end;
end;

//-------- inhaltIstGanzeZahl (public) ---------------------------------
function TSuMTextfeld.inhaltIstGanzeZahl : Wahrheitswert;
  var lWert: GanzeZahl;
      code : integer;
begin
  val(self.inhaltAlsText,lWert,Code);
  result:=(code=0);
end;

//-------- inhaltIstZahl (public) --------------------------------------
function TSuMTextfeld.inhaltIstZahl : Wahrheitswert;
  var lWert: Zahl;
      lcode : integer;
begin
  val(self.inhaltAlsText,lWert,lCode);
  result:=(lcode=0);
end;

//-------- inhaltIstZeichenkette (public) ------------------------------
function TSuMTextfeld.inhaltIstZeichenkette : Wahrheitswert;
begin
  result:=true;
end;

//-------- links (public) ----------------------------------------------
function TSuMTextfeld.links : Zahl;
begin
 result:=self.zXpos
end;

//-------- oben (public) -----------------------------------------------
function TSuMTextfeld.oben : Zahl;
begin
  result:=self.zYPos;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TSuMTextfeld.gibFrei;
begin
   hatBuntStift.bewegeBis(zXPos-1,zYPos-1);
   hatBuntStift.setzeFarbe(weiss);
   hatBuntStift.normal;
   hatBuntStift.setzeFuellmuster(gefuellt);
   hatBuntStift.zeichneRechteck(zBreite+2,zHoehe+2);

  hatBuntstift.gibFrei;
  inherited gibFrei
end;

end.
