UNIT mTBruchrechner;

interface

uses   mSuM, mTBruch;
// Uses-Klausel ggf. anpassen

type
   TBruchrechner = CLASS

     // Attribute
     public
        kenntBruch1 : TBruch;
        kenntBruch2 : TBruch;
        kenntErgebnisbruch : TBruch;

     // Methoden
     public
        constructor init(pBruch1,pBruch2,Ergebnisbruch:TBruch);
        procedure addiere;
        procedure dividiere;
        procedure macheGleichnamig;
        procedure multipliziere;
        procedure setzeBruch1(pBruch:TBruch);
        procedure setzeBruch2(pBruch:TBruch);
        procedure subtrahiere;
        function ergebnisbruch : TBruch;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TBruchrechner: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TBruchrechner.init(pBruch1,pBruch2,Ergebnisbruch:TBruch);
begin
  kenntBruch1:=pBruch1;
  kenntBruch2:=pBruch2;
  kenntErgebnisbruch := Ergebnisbruch;
end;

//-------- addiere (public) --------------------------------------------
procedure TBruchrechner.addiere;
begin
  kenntErgebnisbruch.setzeZaehler(kenntBruch1.zaehler*kenntBruch2.nenner
    + kenntBruch2.zaehler*kenntBruch1.nenner);
  kenntErgebnisbruch.setzeNenner(kenntBruch1.nenner*kenntBruch2.nenner);
  kenntErgebnisbruch.kuerzevoll;

end;

//-------- dividiere (public) ------------------------------------------
procedure TBruchrechner.dividiere;
begin
  kenntBruch2.kehrbruch;
  self.multipliziere;
  kenntBruch2.kehrbruch;
end;

//-------- macheGleichnamig (public) -----------------------------------
procedure TBruchrechner.macheGleichnamig;
  var lHauptnenner : GanzeZahl;
begin
  kenntBruch1.kuerzeVoll;
  kenntBruch2.kuerzeVoll;
  lHauptnenner:=kenntBruch1.nenner*kenntBruch2.nenner;
  kenntBruch1.erweitereUm(lHauptnenner div kenntBruch1.nenner);
  kenntBruch2.erweitereUm(lHauptnenner div kenntBruch2.nenner);
end;

//-------- multipliziere (public) --------------------------------------
procedure TBruchrechner.multipliziere;
begin
  kenntErgebnisbruch.setzeZaehler(kenntBruch1.zaehler*kenntBruch2.zaehler);
  kenntErgebnisbruch.setzeNenner(kenntBruch1.nenner*kenntBruch2.nenner);
  kenntErgebnisbruch.kuerzevoll;
end;

//-------- setzeBruch1 (public) ----------------------------------------
procedure TBruchrechner.setzeBruch1(pBruch:TBruch);
begin
  kenntBruch1:=pBruch;
end;

//-------- setzeBruch2 (public) ----------------------------------------
procedure TBruchrechner.setzeBruch2(pBruch:TBruch);
begin
  kenntBruch2:=pBruch;
end;

//-------- subtrahiere (public) ----------------------------------------
procedure TBruchrechner.subtrahiere;
begin
  kenntErgebnisbruch.setzeZaehler(kenntBruch1.zaehler*kenntBruch2.nenner
    - kenntBruch2.zaehler*kenntBruch1.nenner);
  kenntErgebnisbruch.setzeNenner(kenntBruch1.nenner*kenntBruch2.nenner);
  kenntErgebnisbruch.kuerzevoll;
end;

//-------- ergebnisbruch (public) --------------------------------------
function TBruchrechner.ergebnisbruch : TBruch;
begin
  result:=kenntErgebnisbruch;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TBruchrechner.gibFrei;
begin
end;

end.
