UNIT mTBruchrechner;

interface

uses   mSum,mTBruch;
// Uses-Klausel ggf. anpassen

type
   TBruchrechner = CLASS

     // Attribute
     public
        kenntBruch1 : TBruch;
        kenntBruch2 : TBruch;
        kenntBruchE : TBruch;

     //Objektbeziehungen:
        // kenntTBruch1, // kenntTBruch2, // kenntTBruch3 : TBruch;

     // Methoden
     private
        function kgv (a,b:GanzeZahl) : ganzeZahl;

     public
        constructor init(pBruch1,pBruch2,pEBruch:TBruch);
        procedure addiere;
        procedure dividiere;
        procedure macheGleichnamig;
        procedure multipliziere;
        procedure setzeBruch1(pBruch:TBruch);
        procedure setzeBruch2(pBruch:TBruch);
        procedure subtrahiere;
        function ergebnisbruch : TBruch;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TBruchrechner: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TBruchrechner.init(pBruch1,pBruch2,pEbruch:TBruch);
begin
  kenntBruch1 := pBruch1;
  kenntBruch2 := pBruch2;
  kenntBruchE := pEBruch;
end;

//-------- kgv (private) --------------------------------------------
function TBruchrechner.kgv (a,b:ganzeZahl): ganzeZahl;
Var h : ganzeZahl;
begin
  if a<b then begin h:=a; a:=b; b:=h; end;
  h := a;
  While (a mod b > 0) do a:= a+h;
  result := a;
end;

//-------- addiere (public) --------------------------------------------
procedure TBruchrechner.addiere;
begin
  macheGleichnamig;
  kenntBruchE.setzeNenner(kenntBruch1.nenner);
  kenntBruchE.setzeZaehler(kenntBruch1.zaehler+kenntBruch2.zaehler);
  kenntBruchE.kuerzeVoll;
end;

//-------- dividiere (public) ------------------------------------------
procedure TBruchrechner.dividiere;
begin
  kenntBruchE.setzeZaehler (kenntBruch1.zaehler * kenntBruch2.nenner );
  kenntBruchE.setzenenner  (kenntBruch1.nenner  * kenntBruch2.zaehler);
  kenntBruchE.kuerzeVoll;
end;

//-------- macheGleichnamig (public) -----------------------------------
procedure TBruchrechner.macheGleichnamig;
Var kgv_ : ganzeZahl;
begin
  kgv_ := kgv(kenntBruch1.nenner, kenntBruch2.nenner);
  kenntBruch1.erweitereUm (kgv_ div kenntbruch1.nenner);
  kenntBruch2.erweitereUm (kgv_ div kenntbruch2.nenner);
end;

//-------- multipliziere (public) --------------------------------------
procedure TBruchrechner.multipliziere;
begin
  kenntBruchE.setzeZaehler (kenntBruch1.zaehler * kenntBruch2.zaehler);
  kenntBruchE.setzenenner  (kenntBruch1.nenner  * kenntBruch2.nenner );
  kenntBruchE.kuerzeVoll;
end;

//-------- setzeBruch1 (public) ----------------------------------------
procedure TBruchrechner.setzeBruch1(pBruch:TBruch);
begin
  kenntBruch1 := pBruch;
end;

//-------- setzeBruch2 (public) ----------------------------------------
procedure TBruchrechner.setzeBruch2(pBruch:TBruch);
begin
  kenntBruch2 := pBruch;
end;

//-------- subtrahiere (public) ----------------------------------------
procedure TBruchrechner.subtrahiere;
begin
  macheGleichnamig;
  kenntBruchE.setzeNenner(kenntBruch1.nenner);
  kenntBruchE.setzeZaehler(kenntBruch1.zaehler-kenntBruch2.zaehler);
  kenntBruchE.kuerzeVoll;
end;

//-------- ergebnisbruch (public) --------------------------------------
function TBruchrechner.ergebnisbruch : TBruch;
begin
  result := kenntBruchE;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TBruchrechner.gibFrei;
begin
  //nix!
end;

end.
