unit mFormBruchrechner;
// nderungen:
// 0.&1.
// Alle Operationen zur Ereignisverwaltung werden vom System bernommen,
// daher mssen nur die Methoden geschrieben werden, die den Tastendrcken
// zugeordnet werden. Sie rufen die zugeordneten Rechenoperationen auf.
// 2.
// keine nderungen

interface

uses
  Windows, Messages, SysUtils, {Variants,D6} Classes, Graphics, Controls, Forms,
  Dialogs, mTBruch, mTBruchrechner, StdCtrls, mTextfeld, mKnopf, mEtikett;

type
  TForm1 = class(TForm)
    // Oberflchenobjekte
    Bruchstrich1    :  TEtikett;
    Bruchstrich2    :  TEtikett;
    Bruchstrich3    :  TEtikett;
    GleichZeichen   :  TEtikett;
    KnopfPlus       :  TKnopf;
    KnopfMinus      :  TKnopf;
    KnopfMal        :  TKnopf;
    KnopfDiv        :  TKnopf;
    KnopfEnde       :  TKnopf;
    TextFeldZ1      :  TTextfeld;
    TextFeldN1      :  TTextfeld;
    TextFeldZ2      :  TTextfeld;
    TextFeldN2      :  TTextfeld;
    TextFeldZE      :  TTextfeld;
    TextFeldNE      :  TTextfeld;

    // Methoden, von den Oberflchenobjekten ausgelst

    procedure FormCreate (Sender: TObject);
    procedure FormClose  (Sender: TObject; var Action: TCloseAction);

    procedure KnopfEndeGeklickt(Sender: TObject);

    procedure KnopfPlusGeklickt(Sender: TObject);
    procedure KnopfMinusGeklickt(Sender: TObject);
    procedure KnopfMalGeklickt(Sender: TObject);
    procedure KnopfDivGeklickt(Sender: TObject);

  private
    { Private declarations }
    // Objektbeziehungen: hat: Bruchx:TBruch, Bruchrechner:TBruchrechner
    Bruch1          :  TBruch;
    Bruch2          :  TBruch;
    BruchE          :  TBruch;
    Bruchrechner    :  TBruchrechner;
    
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Bruch1:=TBruch.init(2,3);
  TextfeldZ1.setzeInhalt(Bruch1.zaehler);
  TextfeldN1.setzeInhalt(Bruch1.nenner);

  Bruch2:=TBruch.init(1,6);
  TextfeldZ2.setzeInhalt(Bruch2.zaehler);
  TextfeldN2.setzeInhalt(Bruch2.nenner);

  BruchE:=TBruch.init(0,0);
  TextfeldZE.setzeInhalt(BruchE.zaehler);
  TextfeldNE.setzeInhalt(BruchE.nenner);

  Bruchrechner:=TBruchrechner.init(Bruch1,Bruch2,BruchE);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin

  Bruch1.gibfrei;
  TextfeldZ1.gibFrei;
  TextfeldN1.gibfrei;

  Bruch2.gibfrei;
  TextfeldZ2.gibfrei;
  TextfeldN2.gibfrei;

  BruchE.gibfrei;
  TextfeldZE.gibfrei;
  TextfeldNE.gibfrei;

  Bruchrechner.gibfrei;

end;

procedure TForm1.KnopfEndeGeklickt(Sender: TObject);
begin
  close;
end;

procedure TForm1.KnopfPlusGeklickt(Sender: TObject);
begin
  Bruch1.setzeZaehler(TextFeldZ1.InhaltAlsGanzeZahl);
  Bruch1.setzeNenner (TextFeldN1.InhaltAlsGanzeZahl);
  Bruch2.setzeZaehler(TextFeldZ2.InhaltAlsGanzeZahl);
  Bruch2.setzeNenner (TextFeldN2.InhaltAlsGanzeZahl);
  Bruchrechner.addiere;
  TextfeldZE.setzeInhalt(BruchE.zaehler);
  TextfeldNE.setzeInhalt(BruchE.nenner);
end;

procedure TForm1.KnopfMinusGeklickt(Sender: TObject);
begin
  Bruch1.setzeZaehler(TextFeldZ1.InhaltAlsGanzeZahl);
  Bruch1.setzeNenner (TextFeldN1.InhaltAlsGanzeZahl);
  Bruch2.setzeZaehler(TextFeldZ2.InhaltAlsGanzeZahl);
  Bruch2.setzeNenner (TextFeldN2.InhaltAlsGanzeZahl);
  Bruchrechner.subtrahiere;
  TextfeldZE.setzeInhalt(BruchE.zaehler);
  TextfeldNE.setzeInhalt(BruchE.nenner);
end;

procedure TForm1.KnopfMalGeklickt(Sender: TObject);
begin
  Bruch1.setzeZaehler(TextFeldZ1.InhaltAlsGanzeZahl);
  Bruch1.setzeNenner (TextFeldN1.InhaltAlsGanzeZahl);
  Bruch2.setzeZaehler(TextFeldZ2.InhaltAlsGanzeZahl);
  Bruch2.setzeNenner (TextFeldN2.InhaltAlsGanzeZahl);
  Bruchrechner.multipliziere;
  TextfeldZE.setzeInhalt(BruchE.zaehler);
  TextfeldNE.setzeInhalt(BruchE.nenner);
end;

procedure TForm1.KnopfDivGeklickt(Sender: TObject);
begin
  Bruch1.setzeZaehler(TextFeldZ1.InhaltAlsGanzeZahl);
  Bruch1.setzeNenner (TextFeldN1.InhaltAlsGanzeZahl);
  Bruch2.setzeZaehler(TextFeldZ2.InhaltAlsGanzeZahl);
  Bruch2.setzeNenner (TextFeldN2.InhaltAlsGanzeZahl);
  Bruchrechner.dividiere;
  TextfeldZE.setzeInhalt(BruchE.zaehler);
  TextfeldNE.setzeInhalt(BruchE.nenner);
end;

end.
