UNIT mTBruch;
// nderungen:
// 1.
// Function "ggT" benutzt Betrge, so dass auch Brche mit
// negativem Zhler oder Nenner richtig gekrzt werden.
// Hat eines der beiden Argumente den Wert 0, so ist das andere
// der ggT. Sonst gegenber SuM-Version unverndert.
// 2.
// Alle Referenzen auf SuM entfernt
// => "ganzeZahl" -> "Integer"; "Zahl" -> "Real"
// "zNenner", "zZaehler" sind private!

interface

// uses;
// Uses-Klausel ggf. anpassen

type
   TBruch = CLASS

     private

     // Attribute

        zNenner  : Integer;
        zZaehler : Integer;

     // Methoden

        function ggt(p1,p2:Integer) : Integer;

     public
        constructor init(pZaehler,pNenner:Integer);
        procedure erweitereUm(pZahl:Integer);
        procedure kehrbruch;
        procedure kuerzeUm(pZahl:Integer);
        procedure kuerzeVoll;
        procedure setzeNenner(pNenner:Integer);
        procedure setzeZaehler(pZaehler:Integer);
        function dezimalwert : Real;
        function nenner : Integer;
        function zaehler : Integer;
        destructor gibFrei;

   end;

implementation

//-------- ggt (private) -------------------------------------------------------
function TBruch.ggt(p1,p2:Integer) : Integer;
Var h : Integer;
begin
  p2 := Abs(p2); p1 := Abs(p1);
  if p2 > p1 then begin h:=p1; p1:=p2; p2:=h; end;
  if p2 > 0  then begin
                  while ((p1 mod p2)>0) do
                         begin
                         h  := p1;
                         p1 := p2;
                         p2 := h mod p2;
                         end;
                  result := p2;
                  end
             else result := p1;
end;

//-------- init (public) -------------------------------------------------------
constructor TBruch.init(pZaehler,pNenner:Integer);
begin
 zZaehler := pZaehler;
 zNenner  := pNenner;
end;

//-------- erweitereUm (public) ------------------------------------------------
procedure TBruch.erweitereUm(pZahl:Integer);
begin
  zZaehler := zZaehler * pZahl;
  zNenner  := zNenner  * pZahl;
end;

//-------- kehrbruch (public) --------------------------------------------------
procedure TBruch.kehrbruch;
Var h:Integer;
begin
  h        := zZaehler;
  zZaehler := zNenner;
  zNenner  := h;
end;

//-------- kuerzeUm (public) ---------------------------------------------------
procedure TBruch.kuerzeUm(pZahl:Integer);
begin
  zNenner := zNenner  div pZahl;
  zZaehler:= zZaehler div pZahl;
end;

//-------- kuerzeVoll (public) -------------------------------------------------
procedure TBruch.kuerzeVoll;
begin
  kuerzeUm (ggt(zZaehler,zNenner));
end;

//-------- setzeNenner (public) ------------------------------------------------
procedure TBruch.setzeNenner(pNenner:Integer);
begin
  zNenner := pNenner;
end;

//-------- setzeZaehler (public) -----------------------------------------------
procedure TBruch.setzeZaehler(pZaehler:Integer);
begin
  zZaehler := pZaehler;
end;

//-------- dezimalwert (public) ------------------------------------------------
function TBruch.dezimalwert : Real;
begin
  result := zZaehler/zNenner;
end;

//-------- nenner (public) -----------------------------------------------------
function TBruch.nenner : Integer;
begin
  result := zNenner;
end;

//-------- zaehler (public) ----------------------------------------------------
function TBruch.zaehler : Integer;
begin
  result := zZaehler;
end;

//-------- gibFrei (public) ----------------------------------------------------
destructor TBruch.gibFrei;
begin
  //nix!
end;

end.
