UNIT mTBruchrechner;
// nderungen:
// 1.
// Gegenber SuM-Version unverndert.
// 2.
// Alle Referenzen auf SuM entfernt
// => "ganzeZahl" -> "Integer"; "Zahl" -> "Real"
// Brche jetzt "private", Ebenso "machegleichnamig"
// Die Methoden "SetzeBruchx" und die Anfrage "ergebnisbruch" sind berflssig,
// solange wie hier mit festen Argumentbrchen und festem Ergebnisbruch
// gearbeitet wird. Ihre Deklaration offenbart einen Denkfehler:
// "kenntBruchx" sind keine Kopien der Brche in "mFormBruchrechner", sondern
// Referenzen auf die dort erzeugten Brche. Damit ist jede dort an den Brchen
// erfolgte nderung auch fr den Rechenprozess verfgbar und umgekehrt steht
// das Rechenergebnis auch dort sofort zur Verfgung. Dies zeigt sich auch
// darin, dass diese Methoden in "mFormBruchrechner" nicht aufgerufen werden.

interface

uses   mTBruch;

type
   TBruchrechner = CLASS

     private
     //Objektbeziehungen: kennt: kenntBruch1, kenntBruch2, kenntBruch3 : TBruch;
        kenntBruch1 : TBruch;
        kenntBruch2 : TBruch;
        kenntBruchE : TBruch;

     // Methoden

        function  kgv (a,b:Integer) : Integer;
        procedure macheGleichnamig;

     public
        constructor init(pBruch1,pBruch2,pEBruch:TBruch);
        procedure addiere;
        procedure subtrahiere;
        procedure multipliziere;
        procedure dividiere;
        destructor gibFrei;

   end;

implementation

//-------- init (public) -------------------------------------------------------
constructor TBruchrechner.init(pBruch1,pBruch2,pEbruch:TBruch);
begin
  kenntBruch1 := pBruch1;
  kenntBruch2 := pBruch2;
  kenntBruchE := pEBruch;
end;

//-------- kgv (private) -------------------------------------------------------
function TBruchrechner.kgv (a,b:Integer): Integer;
Var h : Integer;
begin
  if a<b then begin h:=a; a:=b; b:=h; end;
  h := a;
  While (a mod b > 0) do a:= a+h;
  result := a;
end;

//-------- macheGleichnamig (private) ------------------------------------------
procedure TBruchrechner.macheGleichnamig;
Var kgv_ : Integer;
begin
  kgv_ := kgv(kenntBruch1.nenner, kenntBruch2.nenner);
  kenntBruch1.erweitereUm (kgv_ div kenntbruch1.nenner);
  kenntBruch2.erweitereUm (kgv_ div kenntbruch2.nenner);
end;

//-------- addiere (public) ----------------------------------------------------
procedure TBruchrechner.addiere;
begin
  macheGleichnamig;
  kenntBruchE.setzeNenner(kenntBruch1.nenner);
  kenntBruchE.setzeZaehler(kenntBruch1.zaehler+kenntBruch2.zaehler);
  kenntBruchE.kuerzeVoll;
end;

//-------- subtrahiere (public) ------------------------------------------------
procedure TBruchrechner.subtrahiere;
begin
  macheGleichnamig;
  kenntBruchE.setzeNenner(kenntBruch1.nenner);
  kenntBruchE.setzeZaehler(kenntBruch1.zaehler-kenntBruch2.zaehler);
  kenntBruchE.kuerzeVoll;
end;

//-------- multipliziere (public) ----------------------------------------------
procedure TBruchrechner.multipliziere;
begin
  kenntBruchE.setzeZaehler (kenntBruch1.zaehler * kenntBruch2.zaehler);
  kenntBruchE.setzenenner  (kenntBruch1.nenner  * kenntBruch2.nenner );
  kenntBruchE.kuerzeVoll;
end;

//-------- dividiere (public) --------------------------------------------------
procedure TBruchrechner.dividiere;
begin
  kenntBruchE.setzeZaehler (kenntBruch1.zaehler * kenntBruch2.nenner );
  kenntBruchE.setzenenner  (kenntBruch1.nenner  * kenntBruch2.zaehler);
  kenntBruchE.kuerzeVoll;
end;

//-------- gibFrei (public) ----------------------------------------------------
destructor TBruchrechner.gibFrei;
begin
  //nix!
end;

end.
