unit mFormBruchrechner;
// nderungen:
// 0.&1.
// Alle Operationen zur Ereignisverwaltung werden vom System bernommen,
// daher mssen nur die Methoden geschrieben werden, die den Tastendrcken
// zugeordnet werden. Sie rufen die zugeordneten Rechenoperationen auf.
// 2.
// keine nderungen
// 3.
// Die Umstrukturierung von TBruch macht technische nderungen ntig.
// Darber hinaus werden nach dem Bettigen einer Rechentaste jetzt
// die durch "TBruch" normierten und gekrzten Ausgangsbrche angezeigt.
// Fehler bei der Rechnung werden nicht abgefangen.


interface

uses
  Windows, Messages, SysUtils, {Variants,D6} Classes, Graphics, Controls, Forms,
  Dialogs, mTBruch, mTBruchrechner, StdCtrls, mTextfeld, mKnopf, mEtikett;

type
  TForm1 = class(TForm)

    // Oberflchenobjekte
    Bruchstrich1    :  TEtikett;
    Bruchstrich2    :  TEtikett;
    Bruchstrich3    :  TEtikett;
    GleichZeichen   :  TEtikett;
    KnopfPlus       :  TKnopf;
    KnopfMinus      :  TKnopf;
    KnopfMal        :  TKnopf;
    KnopfDiv        :  TKnopf;
    KnopfEnde       :  TKnopf;
    TextFeldZ1      :  TTextfeld;
    TextFeldN1      :  TTextfeld;
    TextFeldZ2      :  TTextfeld;
    TextFeldN2      :  TTextfeld;
    TextFeldZE      :  TTextfeld;
    TextFeldNE      :  TTextfeld;

    // Methoden, von den Oberflchenobjekten ausgelst

    procedure FormCreate (Sender: TObject);
    procedure FormClose  (Sender: TObject; var Action: TCloseAction);

    procedure KnopfEndeGeklickt(Sender: TObject);

    procedure KnopfPlusGeklickt(Sender: TObject);
    procedure KnopfMinusGeklickt(Sender: TObject);
    procedure KnopfMalGeklickt(Sender: TObject);
    procedure KnopfDivGeklickt(Sender: TObject);

  private
    { Private declarations }
    // Objektbeziehungen: hat: Bruchx:TBruch, Bruchrechner:TBruchrechner
    Bruch1          :  TBruch;
    Bruch2          :  TBruch;
    BruchE          :  TBruch;
    Bruchrechner    :  TBruchrechner;
    
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Bruch1:=TBruch.init;
  TextfeldZ1.setzeInhalt(Bruch1.zaehler);
  TextfeldN1.setzeInhalt(Bruch1.nenner);

  Bruch2:=TBruch.init;
  TextfeldZ2.setzeInhalt(Bruch2.zaehler);
  TextfeldN2.setzeInhalt(Bruch2.nenner);

  BruchE:=TBruch.init;
  TextfeldZE.setzeInhalt(BruchE.zaehler);
  TextfeldNE.setzeInhalt(BruchE.nenner);

  Bruchrechner:=TBruchrechner.init(Bruch1,Bruch2,BruchE);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin

  Bruch1.gibfrei;
  TextfeldZ1.gibFrei;
  TextfeldN1.gibfrei;

  Bruch2.gibfrei;
  TextfeldZ2.gibfrei;
  TextfeldN2.gibfrei;

  BruchE.gibfrei;
  TextfeldZE.gibfrei;
  TextfeldNE.gibfrei;

  Bruchrechner.gibfrei;

end;

procedure TForm1.KnopfEndeGeklickt(Sender: TObject);
begin
  close;
end;

procedure TForm1.KnopfPlusGeklickt(Sender: TObject);
begin
  Bruch1.setzeBruch (TextFeldZ1.InhaltAlsGanzeZahl,TextFeldN1.InhaltAlsGanzeZahl);
  Bruch2.setzeBruch (TextFeldZ2.InhaltAlsGanzeZahl,TextFeldN2.InhaltAlsGanzeZahl);
  Bruchrechner.addiere;
  TextfeldZ1.setzeInhalt(Bruch1.zaehler);
  TextfeldN1.setzeInhalt(Bruch1.nenner);
  TextfeldZ2.setzeInhalt(Bruch2.zaehler);
  TextfeldN2.setzeInhalt(Bruch2.nenner);
  TextfeldZE.setzeInhalt(BruchE.zaehler);
  TextfeldNE.setzeInhalt(BruchE.nenner);
end;

procedure TForm1.KnopfMinusGeklickt(Sender: TObject);
begin
  Bruch1.setzeBruch (TextFeldZ1.InhaltAlsGanzeZahl,TextFeldN1.InhaltAlsGanzeZahl);
  Bruch2.setzeBruch (TextFeldZ2.InhaltAlsGanzeZahl,TextFeldN2.InhaltAlsGanzeZahl);
  Bruchrechner.subtrahiere;
  TextfeldZ1.setzeInhalt(Bruch1.zaehler);
  TextfeldN1.setzeInhalt(Bruch1.nenner);
  TextfeldZ2.setzeInhalt(Bruch2.zaehler);
  TextfeldN2.setzeInhalt(Bruch2.nenner);
  TextfeldZE.setzeInhalt(BruchE.zaehler);
  TextfeldNE.setzeInhalt(BruchE.nenner);
end;

procedure TForm1.KnopfMalGeklickt(Sender: TObject);
begin
  Bruch1.setzeBruch (TextFeldZ1.InhaltAlsGanzeZahl,TextFeldN1.InhaltAlsGanzeZahl);
  Bruch2.setzeBruch (TextFeldZ2.InhaltAlsGanzeZahl,TextFeldN2.InhaltAlsGanzeZahl);
  Bruchrechner.multipliziere;
  TextfeldZ1.setzeInhalt(Bruch1.zaehler);
  TextfeldN1.setzeInhalt(Bruch1.nenner);
  TextfeldZ2.setzeInhalt(Bruch2.zaehler);
  TextfeldN2.setzeInhalt(Bruch2.nenner);
  TextfeldZE.setzeInhalt(BruchE.zaehler);
  TextfeldNE.setzeInhalt(BruchE.nenner);
end;

procedure TForm1.KnopfDivGeklickt(Sender: TObject);
begin
  Bruch1.setzeBruch (TextFeldZ1.InhaltAlsGanzeZahl,TextFeldN1.InhaltAlsGanzeZahl);
  Bruch2.setzeBruch (TextFeldZ2.InhaltAlsGanzeZahl,TextFeldN2.InhaltAlsGanzeZahl);
  Bruchrechner.dividiere;
  TextfeldZ1.setzeInhalt(Bruch1.zaehler);
  TextfeldN1.setzeInhalt(Bruch1.nenner);
  TextfeldZ2.setzeInhalt(Bruch2.zaehler);
  TextfeldN2.setzeInhalt(Bruch2.nenner);
  TextfeldZE.setzeInhalt(BruchE.zaehler);
  TextfeldNE.setzeInhalt(BruchE.nenner);
end;

end.
