unit mFormBruchrechner;
// nderungen:
// 0.&1.
// Alle Operationen zur Ereignisverwaltung werden vom System bernommen,
// daher mssen nur die Methoden geschrieben werden, die den Tastendrcken
// zugeordnet werden. Sie rufen die zugeordneten Rechenoperationen auf.
// 2.
// keine nderungen
// 3.
// Die Umstrukturierung von TBruch macht technische nderungen ntig.
// Darber hinaus werden nach dem Bettigen einer Rechentaste jetzt
// die durch "TBruch" normierten und gekrzten Ausgangsbrche angezeigt.
// Fehler bei der Rechnung werden nicht abgefangen.
// 4.
// Technische nderungen wegen der neuen Struktur von "TBruchrechner":
// Die Rechentasten setzen jetzt die Rechenart
// und weisen dann den Bruchrecher an, zu rechnen.
// Das aktuelle Rechenzeichen wird per Feld in der Rechnung ausgegeben,
// das zugehrige TextFeld und die TextFelder fr den Ergebnisbruch sind
// passiviert und knnen nicht mehr manuell verndert werden.
// Private Methoden zum Aktualisieren der Ausgangsbrche und zur Ausgabe.
// Fehler bei der Rechnung werden nicht abgefangen.

interface

uses
  Windows, Messages, SysUtils, {Variants,D6} Classes, Graphics, Controls, Forms,
  Dialogs, mTBruch, mTBruchrechner, StdCtrls, mTextfeld, mKnopf, mEtikett;

type
  TForm1 = class(TForm)

    // Oberflchenobjekte
    Bruchstrich1    :  TEtikett;
    Bruchstrich2    :  TEtikett;
    Bruchstrich3    :  TEtikett;
    GleichZeichen   :  TEtikett;
    Info1           :  TEtikett;
    Info2           :  TEtikett;
    KnopfPlus       :  TKnopf;
    KnopfMinus      :  TKnopf;
    KnopfMal        :  TKnopf;
    KnopfDiv        :  TKnopf;
    KnopfEnde       :  TKnopf;
    TextFeldZ1      :  TTextfeld;
    TextFeldN1      :  TTextfeld;
    TextFeldZ2      :  TTextfeld;
    TextFeldN2      :  TTextfeld;
    TextFeldZE      :  TTextfeld;
    TextFeldNE      :  TTextfeld;
    TextFeldZeichen :  TTextfeld;

    // Methoden, von den Oberflchenobjekten ausgelst

    procedure FormCreate (Sender: TObject);
    procedure FormClose  (Sender: TObject; var Action: TCloseAction);

    procedure KnopfEndeGeklickt(Sender: TObject);

    procedure KnopfPlusGeklickt(Sender: TObject);
    procedure KnopfMinusGeklickt(Sender: TObject);
    procedure KnopfMalGeklickt(Sender: TObject);
    procedure KnopfDivGeklickt(Sender: TObject);

  private
    { Private declarations }
    // Objektbeziehungen: hat: Bruchx:TBruch, Bruchrechner:TBruchrechner
    Bruch1          :  TBruch;
    Bruch2          :  TBruch;
    BruchE          :  TBruch;
    Bruchrechner    :  TBruchrechner;

    procedure aktualisiereBrueche;
    procedure aktualisiereAnzeige;
    
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Hilfsprozeduren, private ----------------------------------------------------
procedure TForm1.aktualisiereBrueche;
begin
  Bruch1.setzeBruch(TextFeldZ1.InhaltAlsGanzeZahl,TextFeldN1.InhaltAlsGanzeZahl);
  Bruch2.setzeBruch(TextFeldZ2.InhaltAlsGanzeZahl,TextFeldN2.InhaltAlsGanzeZahl);
end;

procedure TForm1.aktualisiereAnzeige;
begin
  TextfeldZ1.setzeInhalt(Bruch1.zaehler);
  TextfeldN1.setzeInhalt(Bruch1.nenner);
  TextfeldZ2.setzeInhalt(Bruch2.zaehler);
  TextfeldN2.setzeInhalt(Bruch2.nenner);
  TextfeldZE.setzeInhalt(BruchE.zaehler);
  TextfeldNE.setzeInhalt(BruchE.nenner);
  TextfeldZeichen.setzeInhalt (' '+Bruchrechner.rechenzeichen);
end;

// Formverwaltung --------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  Bruch1:=TBruch.init;
  Bruch2:=TBruch.init;
  BruchE:=TBruch.init;
  Bruchrechner:=TBruchrechner.init(Bruch1,Bruch2,BruchE);
  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Bruch1.gibfrei;
  Bruch2.gibfrei;
  BruchE.gibfrei;
  Bruchrechner.gibfrei;

  TextfeldZ1.gibFrei;
  TextfeldN1.gibfrei;
  TextfeldZ2.gibfrei;
  TextfeldN2.gibfrei;
  TextfeldZE.gibfrei;
  TextfeldNE.gibfrei;
  TextfeldZeichen.gibfrei;
end;

// Knopfaktionen ---------------------------------------------------------------
procedure TForm1.KnopfEndeGeklickt(Sender: TObject);
begin
  close;
end;

procedure TForm1.KnopfPlusGeklickt(Sender: TObject);
begin
  aktualisiereBrueche;
  Bruchrechner.setzeVerknuepfung ('+');
  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.KnopfMinusGeklickt(Sender: TObject);
begin
  aktualisiereBrueche;
  Bruchrechner.setzeVerknuepfung ('-');
  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.KnopfMalGeklickt(Sender: TObject);
begin
  aktualisiereBrueche;
  Bruchrechner.setzeVerknuepfung ('*');
  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.KnopfDivGeklickt(Sender: TObject);
begin
  aktualisiereBrueche;
  Bruchrechner.setzeVerknuepfung ('/');
  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

end.
