unit mFormBruchrechner;
// nderungen:
// 0.&1.
// Alle Operationen zur Ereignisverwaltung werden vom System bernommen,
// daher mssen nur die Methoden geschrieben werden, die den Tastendrcken
// zugeordnet werden. Sie rufen die zugeordneten Rechenoperationen auf.
// 2.
// keine nderungen
// 3.
// Die Umstrukturierung von TBruch macht technische nderungen ntig.
// Darber hinaus werden nach dem Bettigen einer Rechentaste jetzt
// die durch "TBruch" normierten und gekrzten Ausgangsbrche angezeigt.
// Fehler bei der Rechnung werden nicht abgefangen.
// 4.
// Technische nderungen wegen der neuen Struktur von "TBruchrechner":
// Die Rechentasten setzen jetzt die Rechenart
// und weisen dann den Bruchrecher an, zu rechnen.
// Das aktuelle Rechenzeichen wird per Feld in der Rechnung ausgegeben,
// das zugehrige TextFeld und die TextFelder fr den Ergebnisbruch sind
// passiviert und knnen nicht mehr manuell verndert werden.
// Private Methoden zum Aktualisieren der Ausgangsbrche und zur Ausgabe.
// Fehler bei der Rechnung werden nicht abgefangen.
// 5.
// Technische nderungen in "FormCreate", die dem neuen Typ "TBruchPlus"
// Rechnung tragen. Die Absicherungsmglichkeiten werden noch nicht genutzt.
// 6.
// Bei jeder nderung eines Steuerelements
// ( Knpfe zur Wahl der Verknpfung & Eingabefelder )
// wird das Ergebnis aktualisiert, sofern die nderung zulssig ist.
// Ansonsten erfolgt keine Reaktion & der alte Zustand wird wieder hergestellt. 
// Dazu mssen zum ersten Mal auch bei den vier Eingabefeldern Ereignisse aus-
// gewertet werden, hier das Ereignis "EingabeBestaetigt"(Abschluss mit "Enter")
// und "FokusVerloren" ( Anwahl eines anderen Steuerelementes, Abschluss ohne
// "Enter"). Aufgerufen werden jeweils die Methoden "TextFeldxxGeaendert".
// Die fr die Nenner vorgesehenen Methoden fragen "ok" ab, ebenso die fr den
// Zhler von Bruch2 gltige Methode und das Setzen der Verknpfung "/" .
// Damit ist eine vollstndige Absicherung erreicht.
// Die Ausgabe der Rechenzeichen erfolgt jetzt ber vier Etiketten, deren Sicht-
// barkeit umgeschaltet wird. Das ist zwar etwas aufwndig, ermglicht aber eine
// Ausgabe ohne sichtbaren Positionswechsel der Zeichen.

interface

uses
  Windows, Messages, SysUtils, {Variants,D6} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls,
  mTextfeld, mKnopf, mEtikett,
  mTBruch, mTBruchPlus, mTBruchRechner;

type
  TForm1 = class(TForm)

    // Oberflchenobjekte
    Bruchstrich1    :  TEtikett;
    Bruchstrich2    :  TEtikett;
    Bruchstrich3    :  TEtikett;
    ZeichenGleich   :  TEtikett;
    ZeichenPlus     :  TEtikett;
    ZeichenMinus    :  TEtikett;
    ZeichenMal      :  TEtikett;
    ZeichenDiv      :  TEtikett;
    Info1           :  TEtikett;
    Info2           :  TEtikett;
    KnopfPlus       :  TKnopf;
    KnopfMinus      :  TKnopf;
    KnopfMal        :  TKnopf;
    KnopfDiv        :  TKnopf;
    KnopfEnde       :  TKnopf;
    TextFeldZ1      :  TTextfeld;
    TextFeldN1      :  TTextfeld;
    TextFeldZ2      :  TTextfeld;
    TextFeldN2      :  TTextfeld;
    TextFeldZE      :  TTextfeld;
    TextFeldNE      :  TTextfeld;

    // Methoden, von den Oberflchenobjekten ausgelst

    procedure FormCreate (Sender: TObject);
    procedure FormClose  (Sender: TObject; var Action: TCloseAction);

    procedure KnopfEndeGeklickt  (Sender: TObject);

    procedure KnopfPlusGeklickt  (Sender: TObject);
    procedure KnopfMinusGeklickt (Sender: TObject);
    procedure KnopfMalGeklickt   (Sender: TObject);
    procedure KnopfDivGeklickt   (Sender: TObject);
    procedure TextFeldZ1Geaendert(Sender: TObject);
    procedure TextFeldZ2Geaendert(Sender: TObject);
    procedure TextFeldN1Geaendert(Sender: TObject);
    procedure TextFeldN2Geaendert(Sender: TObject);

  private
    { Private declarations }

    // Objektbeziehungen:
    // hat: Bruchx:TBruch/TBruchPlus, Bruchrechner:TBruchrechner
    Bruch1          :  TBruch;
    Bruch2          :  TBruchPlus;
    BruchE          :  TBruch;
    Bruchrechner    :  TBruchrechner;

    procedure aktualisiereZeichen (zeichen:Char);
    procedure aktualisiereAnzeige;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Hilfsprozeduren, private ----------------------------------------------------
procedure TForm1.aktualisiereZeichen (zeichen:Char);
begin
  case zeichen of
  '+':  begin
        ZeichenPlus.zeige;
        ZeichenMinus.verstecke;
        ZeichenMal.verstecke;
        ZeichenDiv.verstecke;
        end;
  '-':  begin
        ZeichenPlus.verstecke;
        ZeichenMinus.zeige;
        ZeichenMal.verstecke;
        ZeichenDiv.verstecke;
        end;
  '*':  begin
        ZeichenPlus.verstecke;
        ZeichenMinus.verstecke;
        ZeichenMal.zeige;
        ZeichenDiv.verstecke;
        end;
  '/':  begin
        ZeichenPlus.verstecke;
        ZeichenMinus.verstecke;
        ZeichenMal.verstecke;
        ZeichenDiv.zeige;
        end;
  end;
end;

procedure TForm1.aktualisiereAnzeige;
begin
  TextfeldZ1.setzeInhalt(Bruch1.zaehler);
  TextfeldN1.setzeInhalt(Bruch1.nenner);
  TextfeldZ2.setzeInhalt(Bruch2.zaehler);
  TextfeldN2.setzeInhalt(Bruch2.nenner);
  TextfeldZE.setzeInhalt(BruchE.zaehler);
  TextfeldNE.setzeInhalt(BruchE.nenner);
  aktualisiereZeichen (Bruchrechner.rechenzeichen)
end;

// Formverwaltung --------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  Bruch1:=TBruch.init;
  Bruch2:=TBruchPlus.init;
  BruchE:=TBruch.init;
  Bruchrechner:=TBruchrechner.init(Bruch1,Bruch2,BruchE);
  Bruch2.initKenntRechner (Bruchrechner);
  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Bruch1.gibfrei;
  Bruch2.gibfrei;
  BruchE.gibfrei;
  Bruchrechner.gibfrei;
end;

// Knopfaktionen ---------------------------------------------------------------
procedure TForm1.KnopfEndeGeklickt(Sender: TObject);
begin
  close;
end;

procedure TForm1.KnopfPlusGeklickt(Sender: TObject);
begin
  Bruchrechner.setzeVerknuepfung ('+');
  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.KnopfMinusGeklickt(Sender: TObject);
begin
  Bruchrechner.setzeVerknuepfung ('-');
  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.KnopfMalGeklickt(Sender: TObject);
begin
  Bruchrechner.setzeVerknuepfung ('*');
  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.KnopfDivGeklickt(Sender: TObject);
begin
  Bruchrechner.setzeVerknuepfung ('/');
  if Bruchrechner.ok then Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.TextFeldZ1Geaendert(Sender: TObject);
begin
  Bruch1.setzeZaehler(TextFeldZ1.InhaltAlsGanzeZahl);
  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.TextFeldZ2Geaendert(Sender: TObject);
begin
  Bruch2.setzeZaehler(TextFeldZ2.InhaltAlsGanzeZahl);
  if Bruchrechner.ok then Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.TextFeldN1Geaendert(Sender: TObject);
begin
  Bruch1.setzeNenner(TextFeldN1.InhaltAlsGanzeZahl);
  if Bruchrechner.ok then Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.TextFeldN2Geaendert(Sender: TObject);
begin
  Bruch2.setzeNenner(TextFeldN2.InhaltAlsGanzeZahl);
  if Bruchrechner.ok then Bruchrechner.rechne;
  aktualisiereAnzeige;
end;


end.
