UNIT mTBruchPlus;
// nderungen:
// 5.
// Will man alle Fehlersituationen abfangen, so unterliegt der zweite Operator
// des Bruchrechners gegenber dem ersten einer zustzlichen Einschrnkung:
// Sofern die Rechenart Division ausgewhlt ist, darf auch dessen Zhler nicht 
// den Wert 0 annehmen. Damit die entsprechende Prfung konsequent im Objekt 
// bleibt, erweitert die Unterklasse "mTbruchPlus" die Klasse "mTBruch" um ein 
// Attribut, in dem ein Verweis auf den Bruchrechner gehalten werden kann,
// sodass dort die aktuelle Rechenart abgefragt werden kann.
// Davon abhngig ist wird in "setzeBruch" (und damit auch in "setzeZaehler")
// geprft, ob der Zhler ggf. den Wert null annimmt und "zok" entsprechend
// gesetzt. Ohne Fehler wird die gleichnamige Methode von "TBruch" aufgerufen.
// "kenntRechner" kann bei der Initialisierung noch nicht gesetzt werden, weil
// das Rechnerobjekt erst nach der Initialisierung der Brche erzeugt wird,
// daher wird dessen Referenz erst spter per "initKenntRechner" bergeben.
// 6.
// keine weitere nderung

interface

uses mTBruch,mTBruchRechner;

type
   TBruchPlus = CLASS(TBruch)

     // Attribute

     private
        kenntRechner : TBruchRechner;

     // Methoden

     public
        constructor init; override;
        procedure initKenntRechner(pRechner:TBruchRechner);
        procedure setzeBruch(pZaehler,pNenner:Integer); override;

   end;

implementation

//-------- init (public) -------------------------------------------------------
constructor TBruchPlus.init;
begin
  inherited init;
  kenntRechner := NIL; // bis durch "initKenntRechner" gesetzt
end;

//-------- initKenntRechner (public) -------------------------------------------
procedure TBruchPLus.initKenntRechner(pRechner:TBruchRechner);
begin
  kenntRechner := pRechner;
end;

//-------- setzeBruch (public) -------------------------------------------------
procedure TBruchPlus.setzeBruch(pZaehler,pNenner:Integer);
begin
  if (kenntRechner.rechenzeichen = '/') and (pZaehler = 0)
     then zok := false
     else inherited setzeBruch(pZaehler,pNenner);
end;

end.
