unit mFormBruchrechner;
// nderungen:
// 0.&1.
// Alle Operationen zur Ereignisverwaltung werden vom System bernommen,
// daher mssen nur die Methoden geschrieben werden, die den Tastendrcken
// zugeordnet werden. Sie rufen die zugeordneten Rechenoperationen auf.
// 2.
// keine nderungen
// 3.
// Die Umstrukturierung von TBruch macht technische nderungen ntig.
// Darber hinaus werden nach dem Bettigen einer Rechentaste jetzt
// die durch "TBruch" normierten und gekrzten Ausgangsbrche angezeigt.
// Fehler bei der Rechnung werden nicht abgefangen.
// 4.
// Technische nderungen wegen der neuen Struktur von "TBruchrechner":
// Die Rechentasten setzen jetzt die Rechenart
// und weisen dann den Bruchrecher an, zu rechnen.
// Das aktuelle Rechenzeichen wird per Feld in der Rechnung ausgegeben,
// das zugehrige TextFeld und die TextFelder fr den Ergebnisbruch sind
// passiviert und knnen nicht mehr manuell verndert werden.
// Private Methoden zum Aktualisieren der Ausgangsbrche und zur Ausgabe.
// Fehler bei der Rechnung werden nicht abgefangen.
// 5.
// Technische nderungen in "FormCreate", die dem neuen Typ "TBruchPlus"
// Rechnung tragen. Die Absicherungsmglichkeiten werden noch nicht genutzt.
// 6.
// Bei jeder nderung eines Steuerelements
// ( Knpfe zur Wahl der Verknpfung & Eingabefelder )
// wird das Ergebnis aktualisiert, sofern die nderung zulssig ist.
// Ansonsten erfolgt keine Reaktion & der alte Zustand wird wieder hergestellt. 
// Dazu mssen zum ersten Mal auch bei den vier Eingabefeldern Ereignisse aus-
// gewertet werden, hier das Ereignis "EingabeBestaetigt"(Abschluss mit "Enter")
// und "FokusVerloren" ( Anwahl eines anderen Steuerelementes, Abschluss ohne
// "Enter"). Aufgerufen werden jeweils die Methoden "TextFeldxxGeaendert".
// Die fr die Nenner vorgesehenen Methoden fragen "ok" ab, ebenso die fr den
// Zhler von Bruch2 gltige Methode und das Setzen der Verknpfung "/" .
// Damit ist eine vollstndige Absicherung erreicht.
// Die Ausgabe der Rechenzeichen erfolgt jetzt ber vier Etiketten, deren Sicht-
// barkeit umgeschaltet wird. Das ist zwar etwas aufwndig, ermglicht aber eine
// Ausgabe ohne sichtbaren Positionswechsel der Zeichen.
// 7b.
// Das Ergebnis kann jetzt in unterschiedlichen Formaten ausgegeben werden:
// - als klassischer (ggf. unechter) Bruch (ggf. mit Nenner 1)
// - als gemischter Bruch, ggf. als Ganzzahl
// - als Dezimalbruch mit drei Nachkommastellen
// Bei allen Darstellungsformen wird das Vorzeichen "-" getrennt ausgegeben
// Die relativ komplexe Darstellung mittels Etiketten wird ausgelagert in die
// neue Klasse "TBruchdarsteller", die dazu bei der Initialisierung
// * die hier definierten Etiketten bergeben bekommt
//   und diese soweit ntig mit Werten belegt
//   und sie je nach Darstellungsart in ihrer Sichtbarkeit umschaltet
// * den Ergebnisbruch "bruchE" kennt, um seine Werte ausgeben zu knnen
// Die Umschaltung erfolgt mittels einer Tasten, die im Objekt "DarstellerE"
// vom Typ "TBruchDarsteller" zur nchsten Darstellung weiterschaltet. Die
// vernderte Darstellung wird dann in "DarstellerE" selbstttig organisiert.
// Die Methode "aktualisiereAnzeige" nach nderung der Ausgangswerte setzt jetzt
// nicht mehr unmittelbar die Werte der Ausgabefelder, sondern ruft den Dienst
// "zeigeAn" von "DarstellerE" auf.
// 8.
// Die Klasse "TBruchDarsteller" war bereits in Version 7 so konzipiert, dass
// mittels mehrerer verschiedener Objekte dieser Klasse auch mehrere Brche
// dargestellt werden knnen. Das ist hier realisiert. Auch den Brchen
// "Bruch1" und "Bruch2" sind Darsteller zugeordnet. Dazu mssen auf der
// Oberflche eine Vielzahl von Etiketten an den entsprechenden Positionen
// erzeugt werden, in denen dann die Ausgabe der Brche erfolgen soll. Anders
// als die Etiketten fr den Ergebnisbruch werden diese a priori nicht sicht-
// bar deklariert, da im Normalzustand die Textfelder fr die Eingabe der
// Brche zu sehen sein sollen. Bei der Initialisierung werden diese den
// jeweiligen Bruchdarstellern bergeben.
//
// Die Klasse "TBruchDarsteller" ist fr "Bruch1" und "Bruch2" um die Mglich-
// keit erweitert worden, auch nicht sichtbare Bruchdarstellungen zu verwalten.
// Die Methode "zeige" schaltet dann den gewnschten Bruch in der vorgewhlten
// Darstellungform sichtbar. Darber hinaus kann "TBruchDarsteller" jetzt auch
// Klammern um einen Bruch darstellen, sofern dieser negativ ist und innerhalb
// eines Rechenterms steht. Davon wird hier bei "Darsteller2" Gebrauch gemacht.
// Nheres zu Realisierung: "TBruchDarsteller".
//
// Die Umschaltung zwischen Eingabefeldern (Standardansicht von Bruch1/2)
// und Darstellung mittels Darsteller1/2 erfolgt hier mittels der Taste
// "TasteUmschalterAlle". Wird sie per Maus bettigt, so lst der zugehrige
// Event "Fokus erhalten" mit der Prozedur "TasteUmschalterUnten" die vern-
// derte Darstellung aus. Erst, wenn die Maustaste losgelassen wird, tritt
// das Ereignis "Geklickt" ein, das hier mittels "TasteUmschalterAlleOben"
// die Rckkehr zur alten Darstellung organisiert. Danach wechselt der Fokus
// zwangsweise auf den Knopf zum Umschalten der Darstellung, damit auch ohne
// weitere Aktion ein evtl. zweites Drcken der Taste "-> alle" wieder den
// Event "Fokus erhalten" auslsen kann.
// Insgesamt wird dadurch erreicht, dass der entprechende Knopf wie eine Taste
// fungiert, die die vernderte Darstellung so lange anzeigt, wie sie gedrckt
// gehalten wird.



interface

uses
  Windows, Messages, SysUtils, {Variants,D6} Classes,
  Graphics, Controls, Forms, Dialogs, StdCtrls,
  mTextfeld, mKnopf, mEtikett,
  mTBruch, mTBruchPlus, mTBruchRechner, mTBruchDarsteller;

type
  TForm1 = class(TForm)

    // Oberflchenobjekte
    Bruchstrich1    :  TEtikett;        // Bruchstriche
    Bruchstrich2    :  TEtikett;

    ZeichenGleich   :  TEtikett;        // Rechenzeichen-Anzeige
    ZeichenPlus     :  TEtikett;
    ZeichenMinus    :  TEtikett;
    ZeichenMal      :  TEtikett;
    ZeichenDiv      :  TEtikett;

    Info1           :  TEtikett;        // Beschriftung
    Info2           :  TEtikett;



    KnopfPlus       :  TKnopf;          // Rechenart umschalten
    KnopfMinus      :  TKnopf;
    KnopfMal        :  TKnopf;
    KnopfDiv        :  TKnopf;

    KnopfUmschalten     : TKnopf;       // Darstellungen umschalten
    TasteUmschaltenAlle : TKnopf;

    KnopfEnde           : TKnopf;       // Beenden

    TextFeldZ1      :  TTextfeld;       // Ein- und Ausgabe der Argumente
    TextFeldN1      :  TTextfeld;
    TextFeldZ2      :  TTextfeld;
    TextFeldN2      :  TTextfeld;

    AllVorzeichen1  : TEtikett;         // Etiketten fr Formatausgabe Bruch1
    StdBruchStrich1 : TEtikett;
    MixBruchStrich1 : TEtikett;
    MixGanzzahl1    : TEtikett;
    MixZaehler1     : TEtikett;
    MixNenner1      : TEtikett;
    StdZaehler1     : TEtikett;
    StdNenner1      : TEtikett;
    Dezimal1        : TEtikett;

    AllVorzeichen2  : TEtikett;         // Etiketten fr Formatausgabe Bruch2
    StdBruchStrich2 : TEtikett;
    MixBruchstrich2 : TEtikett;
    MixGanzzahl2    : TEtikett;
    MixZaehler2     : TEtikett;
    MixNenner2      : TEtikett;
    StdZaehler2     : TEtikett;
    StdNenner2      : TEtikett;
    Dezimal2        : TEtikett;
    KlammerLinks2   : TEtikett;
    KlammerRechts2  : TEtikett;

    AllVorzeichenE  : TEtikett;         // Etiketten fr Formatausgabe BruchE
    StdBruchStrichE : TEtikett;
    MixBruchStrichE : TEtikett;
    MixGanzzahlE    : TEtikett;
    MixZaehlerE     : TEtikett;
    MixNennerE      : TEtikett;
    StdZaehlerE     : TEtikett;
    StdNennerE      : TEtikett;
    DezimalE        : TEtikett;


    // Methoden, von den Oberflchenobjekten ausgelst

    procedure FormCreate (Sender: TObject);
    procedure FormClose  (Sender: TObject; var Action: TCloseAction);

    procedure KnopfEndeGeklickt  (Sender: TObject);

    procedure KnopfPlusGeklickt  (Sender: TObject);
    procedure KnopfMinusGeklickt (Sender: TObject);
    procedure KnopfMalGeklickt   (Sender: TObject);
    procedure KnopfDivGeklickt   (Sender: TObject);

    procedure KnopfUmschaltenGeklickt  (Sender: TObject);
    procedure TasteUmschaltenAlleUnten (Sender: TObject);
    procedure TasteUmschaltenAlleOben  (Sender: TObject);

    procedure TextFeldZ1Geaendert(Sender: TObject);
    procedure TextFeldZ2Geaendert(Sender: TObject);
    procedure TextFeldN1Geaendert(Sender: TObject);
    procedure TextFeldN2Geaendert(Sender: TObject);

  private
    { Private declarations }

    // Objektbeziehungen:
    // hat: BruchX  :TBruch/TBruchPlus
    // Bruchrechner :TBruchrechner
    // DarstellerX  :TBruchDarsteller
    
    Bruch1          :  TBruch;
    Bruch2          :  TBruchPlus;
    BruchE          :  TBruch;

    Bruchrechner    :  TBruchrechner;

    Darsteller1     :  TBruchDarsteller;
    Darsteller2     :  TBruchDarsteller;
    DarstellerE     :  TBruchDarsteller;

    procedure aktualisiereZeichen (zeichen:Char);
    procedure aktualisiereAnzeige;
    procedure textfelderVerstecke;
    procedure textfelderZeige;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Hilfsprozeduren, private ----------------------------------------------------
procedure TForm1.aktualisiereZeichen (zeichen:Char);
begin
  case zeichen of
  '+':  begin
        ZeichenPlus.zeige;
        ZeichenMinus.verstecke;
        ZeichenMal.verstecke;
        ZeichenDiv.verstecke;
        end;
  '-':  begin
        ZeichenPlus.verstecke;
        ZeichenMinus.zeige;
        ZeichenMal.verstecke;
        ZeichenDiv.verstecke;
        end;
  '*':  begin
        ZeichenPlus.verstecke;
        ZeichenMinus.verstecke;
        ZeichenMal.zeige;
        ZeichenDiv.verstecke;
        end;
  '/':  begin
        ZeichenPlus.verstecke;
        ZeichenMinus.verstecke;
        ZeichenMal.verstecke;
        ZeichenDiv.zeige;
        end;
  end;
end;

procedure TForm1.aktualisiereAnzeige;
begin
  TextfeldZ1.setzeInhalt(Bruch1.zaehler);
  TextfeldN1.setzeInhalt(Bruch1.nenner);
  TextfeldZ2.setzeInhalt(Bruch2.zaehler);
  TextfeldN2.setzeInhalt(Bruch2.nenner);
  aktualisiereZeichen (Bruchrechner.rechenzeichen);
  DarstellerE.zeige;
end;

procedure TForm1.textfelderVerstecke;
begin
    TextFeldZ1.verstecke;
    TextFeldN1.verstecke;
    TextFeldZ2.verstecke;
    TextFeldN2.verstecke;
    Bruchstrich1.verstecke;
    Bruchstrich2.verstecke;
end;

procedure TForm1.textfelderZeige;
begin
    TextFeldZ1.zeige;
    TextFeldN1.zeige;
    TextFeldZ2.zeige;
    TextFeldN2.zeige;
    Bruchstrich1.zeige;
    Bruchstrich2.zeige;
end;

// Formverwaltung --------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  Bruch1      := TBruch.init;
  Bruch2      := TBruchPlus.init;
  BruchE      := TBruch.init;
  Bruchrechner:= TBruchrechner.init(Bruch1,Bruch2,BruchE);
  Bruch2.initKenntRechner(Bruchrechner);

  Darsteller1 := TBruchDarsteller.init ( Bruch1,
                                         AllVorzeichen1,
                                         StdBruchStrich1,
                                         MixBruchStrich1,
                                         MixGanzzahl1,
                                         MixZaehler1,
                                         MixNenner1,
                                         StdZaehler1,
                                         StdNenner1,
                                         Dezimal1,
                                         NIL,
                                         NIL            );

  Darsteller2 := TBruchDarsteller.init ( Bruch2,
                                         AllVorzeichen2,
                                         StdBruchStrich2,
                                         MixBruchStrich2,
                                         MixGanzzahl2,
                                         MixZaehler2,
                                         MixNenner2,
                                         StdZaehler2,
                                         StdNenner2,
                                         Dezimal2,
                                         KlammerLinks2,
                                         KlammerRechts2  );

  DarstellerE := TBruchDarsteller.init ( BruchE,
                                         AllVorzeichenE,
                                         StdBruchStrichE,
                                         MixBruchStrichE,
                                         MixGanzzahlE,
                                         MixZaehlerE,
                                         MixNennerE,
                                         StdZaehlerE,
                                         StdNennerE,
                                         DezimalE,
                                         NIL,
                                         NIL            );

  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Bruch1.gibfrei;
  Bruch2.gibfrei;
  BruchE.gibfrei;
  Bruchrechner.gibfrei;
  Darsteller1.gibFrei;
  Darsteller2.gibFrei;
  DarstellerE.gibfrei;
end;

// Knopfaktionen ---------------------------------------------------------------
procedure TForm1.KnopfEndeGeklickt(Sender: TObject);
begin
  close;
end;

procedure TForm1.KnopfPlusGeklickt(Sender: TObject);
begin
  Bruchrechner.setzeVerknuepfung ('+');
  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.KnopfMinusGeklickt(Sender: TObject);
begin
  Bruchrechner.setzeVerknuepfung ('-');
  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.KnopfMalGeklickt(Sender: TObject);
begin
  Bruchrechner.setzeVerknuepfung ('*');
  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.KnopfDivGeklickt(Sender: TObject);
begin
  Bruchrechner.setzeVerknuepfung ('/');
  if Bruchrechner.ok then Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.KnopfUmschaltenGeklickt(Sender: TObject);
begin
  DarstellerE.steppeDarstellung;
end;

procedure TForm1.TasteUmschaltenAlleUnten(Sender: TObject);
// Wird von "KnopfUmschaltenAlle" - Event: "Fokus erhalten" ausgelst.
begin
  TextfelderVerstecke;
  Darsteller1.setzeDarstellung(DarstellerE.modus);
  Darsteller1.zeige;
  Darsteller2.setzeDarstellung(DarstellerE.modus);
  Darsteller2.zeige;
end;

procedure TForm1.TasteUmschaltenAlleOben(Sender: TObject);
// Wird von "KnopfUmschaltenAlle" - Event: "Geklickt" ausgelst.
// Da dieses Ereignis erst beim Loslassen des Mausknopfes ausgelst
// wird, signalisiert es das Ende des Tastvorgangs
begin
  Darsteller1.verstecke;
  Darsteller2.verstecke;
  TextfelderZeige;
// Der Fokus muss wechseln, damit erneutes Drcken von "KnopfUmschaltenAlle"
// mittels des Events "Fokus erhalten" wieder wahrgenommen werden kann.
  KnopfUmschalten.setzeFokus;
end;


procedure TForm1.TextFeldZ1Geaendert(Sender: TObject);
begin
  Bruch1.setzeZaehler(TextFeldZ1.InhaltAlsGanzeZahl);
  Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.TextFeldZ2Geaendert(Sender: TObject);
begin
  Bruch2.setzeZaehler(TextFeldZ2.InhaltAlsGanzeZahl);
  if Bruchrechner.ok then Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.TextFeldN1Geaendert(Sender: TObject);
begin
  Bruch1.setzeNenner(TextFeldN1.InhaltAlsGanzeZahl);
  if Bruchrechner.ok then Bruchrechner.rechne;
  aktualisiereAnzeige;
end;

procedure TForm1.TextFeldN2Geaendert(Sender: TObject);
begin
  Bruch2.setzeNenner(TextFeldN2.InhaltAlsGanzeZahl);
  if Bruchrechner.ok then Bruchrechner.rechne;
  aktualisiereAnzeige;
end;


end.
